<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html;charset=utf-8">
  <title>views.py</title>
  <link rel="stylesheet" href="pycco.css">
</head>
<body>
<div id='container'>
  <div id="background"></div>
  <div class='section'>
    <div class='docs'><h1>views.py</h1></div>
  </div>
  <div class='clearall'>
  <div class='section' id='section-0'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-0'>#</a>
      </div>
      <p>Views where functions and templates are called.
Currently we support the following 15 functions:</p>
<ol>
<li><strong>Read_file</strong> - Open window</li>
<li><strong>Search_term_ncbi</strong> - Manage the Search Term section of the menu</li>
<li><strong>Urls_list</strong> - Manage the User History section of the menu</li>
<li><strong>Urls_upload</strong> - Manage the Upload File section of the menu</li>
<li><strong>Delete_url</strong> - Delete file</li>
<li><strong>Delete_all_urls</strong> - Delete files of user directory</li>
<li><strong>Align_multiple_list</strong> - Show alignment files</li>
<li><strong>Align_multiple_sequence</strong> - Manage the Multiple Alignment section of the menu</li>
<li><strong>Align_sequence</strong> - Manage the Alignment Two Sequences section of the menu</li>
<li><strong>ProteinListView</strong> - Shows the list of all proteins</li>
<li><strong>Logout</strong> - Logout user</li>
<li><strong>Register</strong> - Register</li>
<li><strong>Login</strong> - Login</li>
<li><strong>Help_admin</strong> - HTML manual admin</li>
<li><strong>Help_user</strong> - HTML manual users</li>
</ol>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span></span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-1'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-1'>#</a>
      </div>
      
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">import</span> <span class="nn">os</span>
<span class="kn">from</span> <span class="nn">django.shortcuts</span> <span class="kn">import</span> <span class="n">render</span>
<span class="kn">from</span> <span class="nn">django.shortcuts</span> <span class="kn">import</span> <span class="n">redirect</span>
<span class="kn">from</span> <span class="nn">django.contrib.auth</span> <span class="kn">import</span> <span class="n">logout</span> <span class="k">as</span> <span class="n">do_logout</span>
<span class="kn">from</span> <span class="nn">django.core.paginator</span> <span class="kn">import</span> <span class="n">Paginator</span><span class="p">,</span> <span class="n">EmptyPage</span><span class="p">,</span> <span class="n">PageNotAnInteger</span>
<span class="kn">from</span> <span class="nn">django.contrib.auth</span> <span class="kn">import</span> <span class="n">authenticate</span>
<span class="kn">from</span> <span class="nn">django.contrib.auth.forms</span> <span class="kn">import</span> <span class="n">AuthenticationForm</span>
<span class="kn">from</span> <span class="nn">django.contrib.auth</span> <span class="kn">import</span> <span class="n">login</span> <span class="k">as</span> <span class="n">do_login</span>
<span class="kn">from</span> <span class="nn">django.contrib.auth.forms</span> <span class="kn">import</span> <span class="n">UserCreationForm</span>
<span class="kn">from</span> <span class="nn">django.views.generic</span> <span class="kn">import</span> <span class="n">ListView</span><span class="p">,</span> <span class="n">DetailView</span>
<span class="kn">from</span> <span class="nn">django.core.files.storage</span> <span class="kn">import</span> <span class="n">FileSystemStorage</span>
<span class="kn">from</span> <span class="nn">django.http</span> <span class="kn">import</span> <span class="n">HttpResponse</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-2'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-2'>#</a>
      </div>
      <p>defined in  <a href="forms.html">forms.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">.forms</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">NCBIForm</span><span class="p">,</span>
    <span class="n">UrlForm</span><span class="p">,</span>
    <span class="n">AlighnmentForm</span><span class="p">,</span>
    <span class="n">AlighnmentMultipleForm</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-3'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-3'>#</a>
      </div>
      <p>defined in  <a href="models.html">models.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">.models</span> <span class="kn">import</span> <span class="n">Protein</span><span class="p">,</span> <span class="n">PBD</span><span class="p">,</span> <span class="n">Url</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-4'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-4'>#</a>
      </div>
      <p>defined in  <a href="filters.html">filters.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">.filters</span> <span class="kn">import</span> <span class="n">PbdFilter</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-5'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-5'>#</a>
      </div>
      <p>defined in  <a href="entrez_ncbi.html">entrez_ncbi.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">.entrez_ncbi</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">search_something</span><span class="p">,</span>
    <span class="n">search_something_structure</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-6'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-6'>#</a>
      </div>
      <p>defined in  <a href="alighnw.html">alighnw.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">align.alighnw</span> <span class="kn">import</span> <span class="n">align_nw</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-7'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-7'>#</a>
      </div>
      <p>defined in  <a href="alighsw.html">alighsw.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">align.alighsw</span> <span class="kn">import</span> <span class="n">align_sw</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-8'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-8'>#</a>
      </div>
      <p>defined in  <a href="multialignfasta.html">multialignfasta.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">align.multialignfasta</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">generate_aln_dnd</span><span class="p">,</span>
    <span class="n">write_file_sequences</span><span class="p">,</span>
    <span class="n">delete_dir</span><span class="p">,</span>
    <span class="n">validate_file</span><span class="p">,</span>
    <span class="n">is_fasta_extension</span><span class="p">,</span>
    <span class="n">len_seq_ids</span><span class="p">,</span> <span class="n">empty_sequences</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-9'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-9'>#</a>
      </div>
      <p>from django.contrib.auth.models import User</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-10'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-10'>#</a>
      </div>
      <h3><span id="read_file" href="read_file"> Read_file </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">read_file</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">pk</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-11'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-11'>#</a>
      </div>
      <p>Open window when user click icon glyphicon-new-window</p>
<p>Used in the templates : urls_list , align_multiple_list</p>
<p>Name of the related URL : read_file</p>
<p>Arguments:</p>
<p>request {request} &ndash; request</p>
<p>pk {int} &ndash; pk of url object</p>
<p>Returns:</p>
<p>{} &ndash; open a new window with the content of the file</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">error</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">obj</span> <span class="o">=</span> <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">pk</span><span class="p">)</span>
    <span class="n">path</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">obj</span><span class="o">.</span><span class="n">gb</span><span class="p">)</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">f</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="s1">&#39;r&#39;</span><span class="p">)</span>
        <span class="n">file_content</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>
        <span class="n">f</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">file_content</span><span class="p">,</span> <span class="n">content_type</span><span class="o">=</span><span class="s2">&quot;text/plain&quot;</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="n">error</span> <span class="o">=</span> <span class="s2">&quot;Can&#39;t open this file.&quot;</span>
        <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">error</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-12'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-12'>#</a>
      </div>
      <h3><span id="search_term_ncbi" href="search_term_ncbi"> Search_term_ncbi </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">search_term_ncbi</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-13'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-13'>#</a>
      </div>
      <p>Manage the Search Term section of the menu.</p>
<p>Used in the templates : term_ncbi_search</p>
<p>Name of the related URL : search_term_ncbi</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; show template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">form</span> <span class="o">=</span> <span class="n">NCBIForm</span><span class="p">()</span>
    <span class="n">uploaded_file</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">uploaded_file_structure</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">list_media_user</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s2">&quot;POST&quot;</span><span class="p">:</span>
        <span class="n">form</span> <span class="o">=</span> <span class="n">NCBIForm</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">request</span><span class="o">.</span><span class="n">POST</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">form</span><span class="o">.</span><span class="n">is_valid</span><span class="p">():</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">term</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;term&#39;</span><span class="p">]</span>
                <span class="n">num</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;num_downloads&#39;</span><span class="p">]</span>
                <span class="n">database</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;database&#39;</span><span class="p">]</span>
                <span class="n">user</span> <span class="o">=</span> <span class="s2">&quot;user_&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="o">.</span><span class="n">id</span><span class="p">)</span>
                <span class="n">user_username</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">database</span> <span class="o">==</span> <span class="s1">&#39;structure&#39;</span><span class="p">:</span>
                    <span class="n">uploaded_file_structure</span> <span class="o">=</span> <span class="n">search_something_structure</span><span class="p">(</span>
                        <span class="n">term</span><span class="p">,</span> <span class="n">num</span><span class="p">,</span> <span class="n">user</span><span class="p">,</span> <span class="n">database</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">uploaded_file</span> <span class="o">=</span> <span class="n">search_something</span><span class="p">(</span>
                        <span class="n">term</span><span class="p">,</span> <span class="n">num</span><span class="p">,</span> <span class="n">user</span><span class="p">,</span> <span class="n">user_username</span><span class="p">,</span> <span class="n">database</span><span class="p">)</span>
            <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
                <span class="n">error</span> <span class="o">=</span> <span class="s2">&quot;The page could not be loaded, please try again later.&quot;</span>
                <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s1">&#39;proteins/term_ncbi_search.html&#39;</span><span class="p">,</span>
                  <span class="p">{</span><span class="s1">&#39;form&#39;</span><span class="p">:</span> <span class="n">form</span><span class="p">,</span>  <span class="s1">&#39;urls&#39;</span><span class="p">:</span> <span class="n">uploaded_file</span><span class="p">,</span> <span class="s1">&#39;uploaded_file_structure&#39;</span><span class="p">:</span> <span class="n">uploaded_file_structure</span><span class="p">})</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-14'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-14'>#</a>
      </div>
      <h3><span id="urls_list" href="urls_list"> Urls_list </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">urls_list</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-15'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-15'>#</a>
      </div>
      <p>Manage the User History section of the menu</p>
<p>Used in the templates : urls_list</p>
<p>Name of the related URL : urls_list</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">user</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
    <span class="n">urls</span> <span class="o">=</span> <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">all</span><span class="p">()</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">user</span><span class="o">=</span><span class="n">user</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s1">&#39;proteins/urls_list.html&#39;</span><span class="p">,</span> <span class="p">{</span>
        <span class="s1">&#39;urls&#39;</span><span class="p">:</span> <span class="n">urls</span>
    <span class="p">})</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-16'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-16'>#</a>
      </div>
      <h3><span id="urls_upload" href="urls_upload"> Urls_upload </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">urls_upload</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-17'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-17'>#</a>
      </div>
      <p>Manage the Upload File section of the menu</p>
<p>Used in the templates : urls_upload</p>
<p>Name of the related URL : urls_upload</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">try</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;POST&#39;</span><span class="p">:</span>
            <span class="n">form</span> <span class="o">=</span> <span class="n">UrlForm</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">POST</span><span class="p">,</span> <span class="n">request</span><span class="o">.</span><span class="n">FILES</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">form</span><span class="o">.</span><span class="n">is_valid</span><span class="p">():</span>
                <span class="n">post</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">commit</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
                <span class="n">post</span><span class="o">.</span><span class="n">user</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">user</span>
                <span class="n">post</span><span class="o">.</span><span class="n">sequences</span> <span class="o">=</span> <span class="kc">None</span>
                <span class="n">post</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>
                <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="s1">&#39;urls_list&#39;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">form</span> <span class="o">=</span> <span class="n">UrlForm</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s1">&#39;proteins/urls_upload.html&#39;</span><span class="p">,</span> <span class="p">{</span>
            <span class="s1">&#39;form&#39;</span><span class="p">:</span> <span class="n">form</span>
        <span class="p">})</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="n">error</span> <span class="o">=</span> <span class="s2">&quot;An error has occurred.&quot;</span>
        <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">error</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-18'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-18'>#</a>
      </div>
      <h3><span id="pbd_list" href="pbd_list"> Pbd_list </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">pbd_list</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-19'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-19'>#</a>
      </div>
      <p>Manage the Protein 3D section of the menu</p>
<p>Used in the templates : pbd_list</p>
<p>Name of the related URL : pbd_list</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">protein_list</span> <span class="o">=</span> <span class="n">PBD</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">all</span><span class="p">()</span>
    <span class="n">f</span> <span class="o">=</span> <span class="n">PbdFilter</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="p">,</span> <span class="n">queryset</span><span class="o">=</span><span class="n">protein_list</span><span class="p">)</span>

    <span class="n">paginator</span> <span class="o">=</span> <span class="n">Paginator</span><span class="p">(</span><span class="n">f</span><span class="o">.</span><span class="n">qs</span><span class="p">,</span> <span class="mi">7</span><span class="p">)</span>
    <span class="n">page</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;page&#39;</span><span class="p">)</span>

    <span class="k">try</span><span class="p">:</span>
        <span class="n">proteins</span> <span class="o">=</span> <span class="n">paginator</span><span class="o">.</span><span class="n">page</span><span class="p">(</span><span class="n">page</span><span class="p">)</span>
    <span class="k">except</span> <span class="n">PageNotAnInteger</span><span class="p">:</span>
        <span class="n">proteins</span> <span class="o">=</span> <span class="n">paginator</span><span class="o">.</span><span class="n">page</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="k">except</span> <span class="n">EmptyPage</span><span class="p">:</span>
        <span class="n">proteins</span> <span class="o">=</span> <span class="n">paginator</span><span class="o">.</span><span class="n">page</span><span class="p">(</span><span class="n">paginator</span><span class="o">.</span><span class="n">num_pages</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s1">&#39;proteins/pbd_list.html&#39;</span><span class="p">,</span> <span class="p">{</span>
        <span class="s1">&#39;proteins&#39;</span><span class="p">:</span> <span class="n">proteins</span><span class="p">,</span>
        <span class="s1">&#39;page&#39;</span><span class="p">:</span> <span class="n">page</span><span class="p">,</span>
        <span class="s1">&#39;filter&#39;</span><span class="p">:</span> <span class="n">f</span><span class="p">,</span>
    <span class="p">})</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-20'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-20'>#</a>
      </div>
      <h3><span id="delete_url" href="delete_url"> Delete_url </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">delete_url</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">pk</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-21'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-21'>#</a>
      </div>
      <p>Delete file (of Url model and user directory) when user click icon glyphicon-trash</p>
<p>Used in the templates : urls_list, align_multiple_list</p>
<p>Name of the related URL : delete_url</p>
<p>Arguments:</p>
<p>request {} &ndash; request
  pk </p>
<p>Returns:</p>
<p>{} &ndash; delete file</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;POST&#39;</span><span class="p">:</span>
        <span class="n">url</span> <span class="o">=</span> <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">pk</span><span class="p">,</span> <span class="n">user</span><span class="o">=</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
        <span class="n">url</span><span class="o">.</span><span class="n">delete</span><span class="p">()</span>
    <span class="n">path_refered</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">META</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;HTTP_REFERER&#39;</span><span class="p">))</span>
    <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="n">path_refered</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-22'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-22'>#</a>
      </div>
      <h3><span id="delete_all_urls" href="delete_all_urls"> Delete_all_urls </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">delete_all_urls</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-23'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-23'>#</a>
      </div>
      <p>Delete files of user directory when user click button Delete All</p>
<p>Used in the templates : urls_list</p>
<p>Name of the related URL : delete_all_urls</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; delete directory</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;POST&#39;</span><span class="p">:</span>
        <span class="n">url</span> <span class="o">=</span> <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">all</span><span class="p">()</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">user</span><span class="o">=</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
        <span class="n">url</span><span class="o">.</span><span class="n">delete</span><span class="p">()</span>
        <span class="n">delete_dir</span><span class="p">(</span><span class="s1">&#39;media/user_&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="o">.</span><span class="n">id</span><span class="p">))</span>
    <span class="n">path_refered</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">META</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;HTTP_REFERER&#39;</span><span class="p">))</span>
    <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="n">path_refered</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-24'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-24'>#</a>
      </div>
      <h3><span id="align_multiple_list" href="align_multiple_list"> Align_multiple_list </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">align_multiple_list</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">gb</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-25'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-25'>#</a>
      </div>
      <p>Show alignment files when user click button 
Align of Multiple Sequence Alignment section of menu</p>
<p>Used in the templates : align_multiple_list</p>
<p>Name of the related URL : align_multiple_list</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">urls</span> <span class="o">=</span> <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">all</span><span class="p">()</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">gb__contains</span><span class="o">=</span><span class="n">gb</span><span class="p">,</span> <span class="n">user</span><span class="o">=</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s1">&#39;proteins/align_multiple_list.html&#39;</span><span class="p">,</span> <span class="p">{</span>
        <span class="s1">&#39;urls&#39;</span><span class="p">:</span> <span class="n">urls</span><span class="p">,</span> <span class="s1">&#39;gb&#39;</span><span class="p">:</span> <span class="n">gb</span>
    <span class="p">})</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-26'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-26'>#</a>
      </div>
      <h3><span id="align_multiple_sequence" href="align_multiple_sequence"> Align_multiple_sequence </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-27'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-27'>#</a>
      </div>
      <p>Manage the Multiple Alignment section of the menu</p>
<p>Call functions : align_multiple_list</p>
<p>Used in the templates : align_multiple_sequence</p>
<p>Name of the related URL : align_multiple_sequence</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">align_multiple_sequence</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-28'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-28'>#</a>
      </div>
      
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">errornogb</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">errorseq</span> <span class="o">=</span> <span class="s2">&quot; &quot;</span>
    <span class="n">errorfile</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">errorlen</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;POST&#39;</span><span class="p">:</span>
        <span class="n">form</span> <span class="o">=</span> <span class="n">AlighnmentMultipleForm</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">POST</span><span class="p">,</span> <span class="n">request</span><span class="o">.</span><span class="n">FILES</span><span class="p">)</span>
        <span class="n">seq</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">POST</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;sequences&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
        <span class="n">gb</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">FILES</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;gb&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">seq</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span> <span class="ow">or</span> <span class="n">seq</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">gb</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span> <span class="ow">or</span> <span class="n">gb</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">errornogb</span> <span class="o">=</span> <span class="s2">&quot;Please enter a File or Sequences.&quot;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">is_fasta_extension</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">gb</span><span class="p">))</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">form</span><span class="o">.</span><span class="n">is_valid</span><span class="p">():</span>
                        <span class="n">fil</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">FILES</span><span class="p">[</span><span class="s1">&#39;gb&#39;</span><span class="p">]</span>
                        <span class="n">sequences</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;sequences&#39;</span><span class="p">]</span>
                        <span class="n">post</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">commit</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
                        <span class="n">post</span><span class="o">.</span><span class="n">title</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">fil</span><span class="p">)</span>
                        <span class="n">post</span><span class="o">.</span><span class="n">types</span> <span class="o">=</span> <span class="s1">&#39;MultiFasta&#39;</span>
                        <span class="n">post</span><span class="o">.</span><span class="n">user</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">user</span>
                        <span class="n">post</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>

                        <span class="k">if</span> <span class="n">empty_sequences</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">post</span><span class="o">.</span><span class="n">gb</span><span class="p">))</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
                            <span class="k">if</span> <span class="n">validate_file</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">post</span><span class="o">.</span><span class="n">gb</span><span class="p">))</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
                                <span class="n">tup_files</span> <span class="o">=</span> <span class="n">generate_aln_dnd</span><span class="p">(</span>
                                    <span class="nb">str</span><span class="p">(</span><span class="n">post</span><span class="o">.</span><span class="n">gb</span><span class="p">),</span> <span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
                                <span class="nb">print</span><span class="p">(</span><span class="n">tup_files</span><span class="p">)</span>
                                <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="s1">&#39;align_multiple_list&#39;</span><span class="p">,</span> <span class="n">gb</span><span class="o">=</span><span class="n">tup_files</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">+</span><span class="s1">&#39;.&#39;</span><span class="p">)</span>
                            <span class="k">else</span><span class="p">:</span>
                                <span class="n">errorseq</span> <span class="o">=</span> <span class="s2">&quot;The number of sequences must be greater than or equal to two, the name of the sequences must be unique&quot;</span>
                        <span class="k">else</span><span class="p">:</span>
                            <span class="n">errorlen</span> <span class="o">=</span> <span class="s2">&quot;A sequence can not be empty, sequences can only be letters, sequences names can not  be empty&quot;</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">errorfile</span> <span class="o">=</span> <span class="s2">&quot;The file must be in fasta format.&quot;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">gb</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span> <span class="ow">or</span> <span class="n">gb</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">path_gb</span> <span class="o">=</span> <span class="n">write_file_sequences</span><span class="p">(</span><span class="n">seq</span><span class="p">,</span> <span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">empty_sequences</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">path_gb</span><span class="p">))</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">validate_file</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">path_gb</span><span class="p">))</span> <span class="o">==</span> <span class="kc">True</span><span class="p">:</span>
                        <span class="n">tup_files</span> <span class="o">=</span> <span class="n">generate_aln_dnd</span><span class="p">(</span>
                            <span class="nb">str</span><span class="p">(</span><span class="n">path_gb</span><span class="p">),</span> <span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
                        <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="s1">&#39;align_multiple_list&#39;</span><span class="p">,</span> <span class="n">gb</span><span class="o">=</span><span class="n">tup_files</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">errorseq</span> <span class="o">=</span> <span class="s2">&quot;The number of sequences must be greater than or equal to two, the name of the sequences must be unique&quot;</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">errorlen</span> <span class="o">=</span> <span class="s2">&quot;A sequence can not be empty, sequences can only be letters, sequences names can not  be empty&quot;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">errornogb</span> <span class="o">=</span> <span class="s2">&quot;Please enter a File or Sequences.&quot;</span>

    <span class="k">else</span><span class="p">:</span>
        <span class="n">form</span> <span class="o">=</span> <span class="n">AlighnmentMultipleForm</span><span class="p">()</span>
    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s1">&#39;proteins/align_multiple_sequence.html&#39;</span><span class="p">,</span> <span class="p">{</span><span class="s1">&#39;form&#39;</span><span class="p">:</span> <span class="n">form</span><span class="p">,</span>
                                                                     <span class="s1">&#39;errornogb&#39;</span><span class="p">:</span> <span class="n">errornogb</span><span class="p">,</span> <span class="s1">&#39;errorseq&#39;</span><span class="p">:</span> <span class="n">errorseq</span><span class="p">,</span> <span class="s1">&#39;errorfile&#39;</span><span class="p">:</span> <span class="n">errorfile</span><span class="p">,</span> <span class="s1">&#39;errorlen&#39;</span><span class="p">:</span> <span class="n">errorlen</span><span class="p">})</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-29'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-29'>#</a>
      </div>
      <h3><span id="align_sequence" href="align_sequence"> Align_sequence </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">align_sequence</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-30'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-30'>#</a>
      </div>
      <p>Manage the Alignment Two Sequences section of the menu</p>
<p>Used in the templates : align_sequence</p>
<p>Name of the related URL : align_sequence</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">form</span> <span class="o">=</span> <span class="n">AlighnmentForm</span><span class="p">()</span>
    <span class="n">alignment</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">alignment_1_names</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">alignment_2_traceback</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">alignment_3_matrix</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">match</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">gap</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;POST&#39;</span><span class="p">:</span>
        <span class="n">form</span> <span class="o">=</span> <span class="n">AlighnmentForm</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">POST</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">form</span><span class="o">.</span><span class="n">is_valid</span><span class="p">():</span>
            <span class="n">secuencia1</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;secuencia1&#39;</span><span class="p">]</span>
            <span class="n">secuencia2</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;secuencia2&#39;</span><span class="p">]</span>
            <span class="n">align</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;align&#39;</span><span class="p">]</span>

            <span class="k">if</span> <span class="n">align</span> <span class="o">==</span> <span class="s2">&quot;1&quot;</span><span class="p">:</span>
                <span class="n">match</span> <span class="o">=</span> <span class="mi">1</span>
                <span class="n">gap</span> <span class="o">=</span> <span class="mi">1</span>
                <span class="n">alignment</span> <span class="o">=</span> <span class="n">align_nw</span><span class="p">(</span><span class="n">secuencia1</span><span class="p">,</span> <span class="n">secuencia2</span><span class="p">)</span>
                <span class="n">alignment_1_names</span> <span class="o">=</span> <span class="n">alignment</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>
                <span class="n">alignment_2_traceback</span> <span class="o">=</span> <span class="n">alignment</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
                <span class="n">alignment_3_matrix</span> <span class="o">=</span> <span class="n">alignment</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span>

            <span class="k">else</span><span class="p">:</span>
                <span class="n">alignment</span> <span class="o">=</span> <span class="n">align_sw</span><span class="p">(</span><span class="n">secuencia1</span><span class="p">,</span> <span class="n">secuencia2</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">alignment</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">!=</span> <span class="s2">&quot;There is no similarity.&quot;</span><span class="p">:</span>
                    <span class="n">match</span> <span class="o">=</span> <span class="mi">3</span>
                    <span class="n">gap</span> <span class="o">=</span> <span class="mi">2</span>
                    <span class="n">alignment_1_names</span> <span class="o">=</span> <span class="n">alignment</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>
                    <span class="n">alignment_2_traceback</span> <span class="o">=</span> <span class="n">alignment</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
                    <span class="n">alignment_3_matrix</span> <span class="o">=</span> <span class="n">alignment</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s1">&#39;proteins/align_sequence.html&#39;</span><span class="p">,</span> <span class="p">{</span><span class="s1">&#39;form&#39;</span><span class="p">:</span> <span class="n">form</span><span class="p">,</span> <span class="s1">&#39;alignment&#39;</span><span class="p">:</span> <span class="n">alignment</span><span class="p">,</span>   <span class="s1">&#39;alignment_1&#39;</span><span class="p">:</span> <span class="n">alignment_1_names</span><span class="p">,</span>
                                                                            <span class="s1">&#39;alignment_2&#39;</span><span class="p">:</span> <span class="n">alignment_2_traceback</span><span class="p">,</span> <span class="s1">&#39;alignment_3&#39;</span><span class="p">:</span> <span class="n">alignment_3_matrix</span><span class="p">,</span>
                                                                            <span class="s1">&#39;match&#39;</span><span class="p">:</span> <span class="n">match</span><span class="p">,</span> <span class="s1">&#39;gap&#39;</span><span class="p">:</span> <span class="n">gap</span><span class="p">})</span>

    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s1">&#39;proteins/align_sequence.html&#39;</span><span class="p">,</span> <span class="p">{</span><span class="s1">&#39;form&#39;</span><span class="p">:</span> <span class="n">form</span><span class="p">,</span> <span class="s1">&#39;alignment_1&#39;</span><span class="p">:</span> <span class="n">alignment_1_names</span><span class="p">,</span>
                                                            <span class="s1">&#39;alignment_2&#39;</span><span class="p">:</span> <span class="n">alignment_2_traceback</span><span class="p">,</span> <span class="s1">&#39;alignment_3&#39;</span><span class="p">:</span> <span class="n">alignment_3_matrix</span><span class="p">,</span>
                                                            <span class="s1">&#39;match&#39;</span><span class="p">:</span> <span class="n">match</span><span class="p">,</span> <span class="s1">&#39;gap&#39;</span><span class="p">:</span> <span class="n">gap</span><span class="p">})</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-31'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-31'>#</a>
      </div>
      <h3><span id="proteinlistview" href="proteinlistview"> ProteinListView </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">class</span> <span class="nc">ProteinListView</span><span class="p">(</span><span class="n">ListView</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-32'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-32'>#</a>
      </div>
      <p>Shows the list of all proteins</p>
<p>Used in the templates : protein_list</p>
<p>Name of the related URL : protein_list</p>
<p>Arguments:</p>
<p>ListView {} &ndash; type of view </p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">model</span> <span class="o">=</span> <span class="n">Protein</span>
    <span class="n">template_name</span> <span class="o">=</span> <span class="s1">&#39;proteins/protein_list.html&#39;</span>
    <span class="n">context_object_name</span> <span class="o">=</span> <span class="s1">&#39;proteins&#39;</span>
    <span class="n">paginate_by</span> <span class="o">=</span> <span class="mi">6</span>
    <span class="n">queryset</span> <span class="o">=</span> <span class="n">Protein</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">all</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-33'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-33'>#</a>
      </div>
      <h3><span id="logout" href="logout"> Logout </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">logout</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-34'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-34'>#</a>
      </div>
      <p>Logout user. Return main page. </p>
<p>Name of the related URL : logout</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; main page</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">do_logout</span><span class="p">(</span><span class="n">request</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-35'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-35'>#</a>
      </div>
      <h3><span id="register" href="register"> Register </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">register</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-36'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-36'>#</a>
      </div>
      <p>Register</p>
<p>Used in the templates : register</p>
<p>Name of the related URL : register</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">form</span> <span class="o">=</span> <span class="n">UserCreationForm</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s2">&quot;POST&quot;</span><span class="p">:</span>
        <span class="n">form</span> <span class="o">=</span> <span class="n">UserCreationForm</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">request</span><span class="o">.</span><span class="n">POST</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">form</span><span class="o">.</span><span class="n">is_valid</span><span class="p">():</span>
            <span class="n">user</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>
            <span class="k">if</span> <span class="n">user</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">do_login</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">user</span><span class="p">)</span>
                <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">)</span>
    <span class="n">form</span><span class="o">.</span><span class="n">fields</span><span class="p">[</span><span class="s1">&#39;username&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">help_text</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">form</span><span class="o">.</span><span class="n">fields</span><span class="p">[</span><span class="s1">&#39;password1&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">help_text</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="n">form</span><span class="o">.</span><span class="n">fields</span><span class="p">[</span><span class="s1">&#39;password2&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">help_text</span> <span class="o">=</span> <span class="kc">None</span>

    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s2">&quot;proteins/register.html&quot;</span><span class="p">,</span> <span class="p">{</span><span class="s1">&#39;form&#39;</span><span class="p">:</span> <span class="n">form</span><span class="p">})</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-37'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-37'>#</a>
      </div>
      <h3><span id="login" href="login"> Login </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">login</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-38'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-38'>#</a>
      </div>
      <p>Login </p>
<p>Used in the templates : login</p>
<p>Name of the related URL : login</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">form</span> <span class="o">=</span> <span class="n">AuthenticationForm</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s2">&quot;POST&quot;</span><span class="p">:</span>
        <span class="n">form</span> <span class="o">=</span> <span class="n">AuthenticationForm</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">request</span><span class="o">.</span><span class="n">POST</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">form</span><span class="o">.</span><span class="n">is_valid</span><span class="p">():</span>
            <span class="n">username</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;username&#39;</span><span class="p">]</span>
            <span class="n">password</span> <span class="o">=</span> <span class="n">form</span><span class="o">.</span><span class="n">cleaned_data</span><span class="p">[</span><span class="s1">&#39;password&#39;</span><span class="p">]</span>
            <span class="n">user</span> <span class="o">=</span> <span class="n">authenticate</span><span class="p">(</span><span class="n">username</span><span class="o">=</span><span class="n">username</span><span class="p">,</span> <span class="n">password</span><span class="o">=</span><span class="n">password</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">user</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">do_login</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">user</span><span class="p">)</span>
                <span class="k">return</span> <span class="n">redirect</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s2">&quot;proteins/login.html&quot;</span><span class="p">,</span> <span class="p">{</span><span class="s1">&#39;form&#39;</span><span class="p">:</span> <span class="n">form</span><span class="p">})</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-39'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-39'>#</a>
      </div>
      <h3><span id="help_admin" href="help_admin"> Help_admin </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">help_admin</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-40'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-40'>#</a>
      </div>
      <p>Show manual admin when user click link Help Admin</p>
<p>Used in the templates : manualAdmin</p>
<p>Name of the related URL :  help_admin</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s2">&quot;manuals/manualAdmin.html&quot;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-41'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-41'>#</a>
      </div>
      <h3><span id="help_user" href="help_user"> Help_user </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">help_user</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-42'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-42'>#</a>
      </div>
      <p>Show manual users when user click link Help User</p>
<p>Used in the templates : manualUsers</p>
<p>Name of the related URL : help_user</p>
<p>Arguments:</p>
<p>request {} &ndash; request</p>
<p>Returns:</p>
<p>{} &ndash; template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">render</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="s2">&quot;manuals/manualUsers.html&quot;</span><span class="p">)</span>

</pre></div>
    </div>
  </div>
  <div class='clearall'></div>
</div>
</body>
